// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rmf_traffic_msgs:msg/ItinerarySet.idl
// generated code does not contain a copyright notice

#ifndef RMF_TRAFFIC_MSGS__MSG__DETAIL__ITINERARY_SET__TRAITS_HPP_
#define RMF_TRAFFIC_MSGS__MSG__DETAIL__ITINERARY_SET__TRAITS_HPP_

#include "rmf_traffic_msgs/msg/detail/itinerary_set__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'itinerary'
#include "rmf_traffic_msgs/msg/detail/schedule_writer_item__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const rmf_traffic_msgs::msg::ItinerarySet & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: participant
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "participant: ";
    value_to_yaml(msg.participant, out);
    out << "\n";
  }

  // member: itinerary
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.itinerary.size() == 0) {
      out << "itinerary: []\n";
    } else {
      out << "itinerary:\n";
      for (auto item : msg.itinerary) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: itinerary_version
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "itinerary_version: ";
    value_to_yaml(msg.itinerary_version, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const rmf_traffic_msgs::msg::ItinerarySet & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<rmf_traffic_msgs::msg::ItinerarySet>()
{
  return "rmf_traffic_msgs::msg::ItinerarySet";
}

template<>
inline const char * name<rmf_traffic_msgs::msg::ItinerarySet>()
{
  return "rmf_traffic_msgs/msg/ItinerarySet";
}

template<>
struct has_fixed_size<rmf_traffic_msgs::msg::ItinerarySet>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rmf_traffic_msgs::msg::ItinerarySet>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rmf_traffic_msgs::msg::ItinerarySet>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // RMF_TRAFFIC_MSGS__MSG__DETAIL__ITINERARY_SET__TRAITS_HPP_
