// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rmf_traffic_msgs:msg/NegotiationProposal.idl
// generated code does not contain a copyright notice

#ifndef RMF_TRAFFIC_MSGS__MSG__DETAIL__NEGOTIATION_PROPOSAL__TRAITS_HPP_
#define RMF_TRAFFIC_MSGS__MSG__DETAIL__NEGOTIATION_PROPOSAL__TRAITS_HPP_

#include "rmf_traffic_msgs/msg/detail/negotiation_proposal__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'to_accommodate'
#include "rmf_traffic_msgs/msg/detail/negotiation_key__traits.hpp"
// Member 'itinerary'
#include "rmf_traffic_msgs/msg/detail/route__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const rmf_traffic_msgs::msg::NegotiationProposal & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: conflict_version
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "conflict_version: ";
    value_to_yaml(msg.conflict_version, out);
    out << "\n";
  }

  // member: proposal_version
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "proposal_version: ";
    value_to_yaml(msg.proposal_version, out);
    out << "\n";
  }

  // member: for_participant
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "for_participant: ";
    value_to_yaml(msg.for_participant, out);
    out << "\n";
  }

  // member: to_accommodate
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.to_accommodate.size() == 0) {
      out << "to_accommodate: []\n";
    } else {
      out << "to_accommodate:\n";
      for (auto item : msg.to_accommodate) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: itinerary
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.itinerary.size() == 0) {
      out << "itinerary: []\n";
    } else {
      out << "itinerary:\n";
      for (auto item : msg.itinerary) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const rmf_traffic_msgs::msg::NegotiationProposal & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<rmf_traffic_msgs::msg::NegotiationProposal>()
{
  return "rmf_traffic_msgs::msg::NegotiationProposal";
}

template<>
inline const char * name<rmf_traffic_msgs::msg::NegotiationProposal>()
{
  return "rmf_traffic_msgs/msg/NegotiationProposal";
}

template<>
struct has_fixed_size<rmf_traffic_msgs::msg::NegotiationProposal>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rmf_traffic_msgs::msg::NegotiationProposal>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rmf_traffic_msgs::msg::NegotiationProposal>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // RMF_TRAFFIC_MSGS__MSG__DETAIL__NEGOTIATION_PROPOSAL__TRAITS_HPP_
