// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rmf_traffic_msgs:srv/RegisterParticipant.idl
// generated code does not contain a copyright notice

#ifndef RMF_TRAFFIC_MSGS__SRV__DETAIL__REGISTER_PARTICIPANT__TRAITS_HPP_
#define RMF_TRAFFIC_MSGS__SRV__DETAIL__REGISTER_PARTICIPANT__TRAITS_HPP_

#include "rmf_traffic_msgs/srv/detail/register_participant__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'description'
#include "rmf_traffic_msgs/msg/detail/participant_description__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const rmf_traffic_msgs::srv::RegisterParticipant_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: description
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "description:\n";
    to_yaml(msg.description, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const rmf_traffic_msgs::srv::RegisterParticipant_Request & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<rmf_traffic_msgs::srv::RegisterParticipant_Request>()
{
  return "rmf_traffic_msgs::srv::RegisterParticipant_Request";
}

template<>
inline const char * name<rmf_traffic_msgs::srv::RegisterParticipant_Request>()
{
  return "rmf_traffic_msgs/srv/RegisterParticipant_Request";
}

template<>
struct has_fixed_size<rmf_traffic_msgs::srv::RegisterParticipant_Request>
  : std::integral_constant<bool, has_fixed_size<rmf_traffic_msgs::msg::ParticipantDescription>::value> {};

template<>
struct has_bounded_size<rmf_traffic_msgs::srv::RegisterParticipant_Request>
  : std::integral_constant<bool, has_bounded_size<rmf_traffic_msgs::msg::ParticipantDescription>::value> {};

template<>
struct is_message<rmf_traffic_msgs::srv::RegisterParticipant_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

inline void to_yaml(
  const rmf_traffic_msgs::srv::RegisterParticipant_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: participant_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "participant_id: ";
    value_to_yaml(msg.participant_id, out);
    out << "\n";
  }

  // member: last_itinerary_version
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "last_itinerary_version: ";
    value_to_yaml(msg.last_itinerary_version, out);
    out << "\n";
  }

  // member: last_route_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "last_route_id: ";
    value_to_yaml(msg.last_route_id, out);
    out << "\n";
  }

  // member: error
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "error: ";
    value_to_yaml(msg.error, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const rmf_traffic_msgs::srv::RegisterParticipant_Response & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<rmf_traffic_msgs::srv::RegisterParticipant_Response>()
{
  return "rmf_traffic_msgs::srv::RegisterParticipant_Response";
}

template<>
inline const char * name<rmf_traffic_msgs::srv::RegisterParticipant_Response>()
{
  return "rmf_traffic_msgs/srv/RegisterParticipant_Response";
}

template<>
struct has_fixed_size<rmf_traffic_msgs::srv::RegisterParticipant_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rmf_traffic_msgs::srv::RegisterParticipant_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rmf_traffic_msgs::srv::RegisterParticipant_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<rmf_traffic_msgs::srv::RegisterParticipant>()
{
  return "rmf_traffic_msgs::srv::RegisterParticipant";
}

template<>
inline const char * name<rmf_traffic_msgs::srv::RegisterParticipant>()
{
  return "rmf_traffic_msgs/srv/RegisterParticipant";
}

template<>
struct has_fixed_size<rmf_traffic_msgs::srv::RegisterParticipant>
  : std::integral_constant<
    bool,
    has_fixed_size<rmf_traffic_msgs::srv::RegisterParticipant_Request>::value &&
    has_fixed_size<rmf_traffic_msgs::srv::RegisterParticipant_Response>::value
  >
{
};

template<>
struct has_bounded_size<rmf_traffic_msgs::srv::RegisterParticipant>
  : std::integral_constant<
    bool,
    has_bounded_size<rmf_traffic_msgs::srv::RegisterParticipant_Request>::value &&
    has_bounded_size<rmf_traffic_msgs::srv::RegisterParticipant_Response>::value
  >
{
};

template<>
struct is_service<rmf_traffic_msgs::srv::RegisterParticipant>
  : std::true_type
{
};

template<>
struct is_service_request<rmf_traffic_msgs::srv::RegisterParticipant_Request>
  : std::true_type
{
};

template<>
struct is_service_response<rmf_traffic_msgs::srv::RegisterParticipant_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // RMF_TRAFFIC_MSGS__SRV__DETAIL__REGISTER_PARTICIPANT__TRAITS_HPP_
