// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rmf_traffic_msgs:msg/ScheduleParticipantPatch.idl
// generated code does not contain a copyright notice

#ifndef RMF_TRAFFIC_MSGS__MSG__DETAIL__SCHEDULE_PARTICIPANT_PATCH__TRAITS_HPP_
#define RMF_TRAFFIC_MSGS__MSG__DETAIL__SCHEDULE_PARTICIPANT_PATCH__TRAITS_HPP_

#include "rmf_traffic_msgs/msg/detail/schedule_participant_patch__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'delays'
#include "rmf_traffic_msgs/msg/detail/schedule_change_delay__traits.hpp"
// Member 'additions'
#include "rmf_traffic_msgs/msg/detail/schedule_change_add__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const rmf_traffic_msgs::msg::ScheduleParticipantPatch & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: participant_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "participant_id: ";
    value_to_yaml(msg.participant_id, out);
    out << "\n";
  }

  // member: itinerary_version
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "itinerary_version: ";
    value_to_yaml(msg.itinerary_version, out);
    out << "\n";
  }

  // member: erasures
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.erasures.size() == 0) {
      out << "erasures: []\n";
    } else {
      out << "erasures:\n";
      for (auto item : msg.erasures) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: delays
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.delays.size() == 0) {
      out << "delays: []\n";
    } else {
      out << "delays:\n";
      for (auto item : msg.delays) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: additions
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.additions.size() == 0) {
      out << "additions: []\n";
    } else {
      out << "additions:\n";
      for (auto item : msg.additions) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const rmf_traffic_msgs::msg::ScheduleParticipantPatch & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<rmf_traffic_msgs::msg::ScheduleParticipantPatch>()
{
  return "rmf_traffic_msgs::msg::ScheduleParticipantPatch";
}

template<>
inline const char * name<rmf_traffic_msgs::msg::ScheduleParticipantPatch>()
{
  return "rmf_traffic_msgs/msg/ScheduleParticipantPatch";
}

template<>
struct has_fixed_size<rmf_traffic_msgs::msg::ScheduleParticipantPatch>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rmf_traffic_msgs::msg::ScheduleParticipantPatch>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rmf_traffic_msgs::msg::ScheduleParticipantPatch>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // RMF_TRAFFIC_MSGS__MSG__DETAIL__SCHEDULE_PARTICIPANT_PATCH__TRAITS_HPP_
