// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rmf_traffic_msgs:srv/RequestChanges.idl
// generated code does not contain a copyright notice
#include "rmf_traffic_msgs/srv/detail/request_changes__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

bool
rmf_traffic_msgs__srv__RequestChanges_Request__init(rmf_traffic_msgs__srv__RequestChanges_Request * msg)
{
  if (!msg) {
    return false;
  }
  // query_id
  // version
  // full_update
  msg->full_update = false;
  return true;
}

void
rmf_traffic_msgs__srv__RequestChanges_Request__fini(rmf_traffic_msgs__srv__RequestChanges_Request * msg)
{
  if (!msg) {
    return;
  }
  // query_id
  // version
  // full_update
}

bool
rmf_traffic_msgs__srv__RequestChanges_Request__are_equal(const rmf_traffic_msgs__srv__RequestChanges_Request * lhs, const rmf_traffic_msgs__srv__RequestChanges_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // query_id
  if (lhs->query_id != rhs->query_id) {
    return false;
  }
  // version
  if (lhs->version != rhs->version) {
    return false;
  }
  // full_update
  if (lhs->full_update != rhs->full_update) {
    return false;
  }
  return true;
}

bool
rmf_traffic_msgs__srv__RequestChanges_Request__copy(
  const rmf_traffic_msgs__srv__RequestChanges_Request * input,
  rmf_traffic_msgs__srv__RequestChanges_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // query_id
  output->query_id = input->query_id;
  // version
  output->version = input->version;
  // full_update
  output->full_update = input->full_update;
  return true;
}

rmf_traffic_msgs__srv__RequestChanges_Request *
rmf_traffic_msgs__srv__RequestChanges_Request__create()
{
  rmf_traffic_msgs__srv__RequestChanges_Request * msg = (rmf_traffic_msgs__srv__RequestChanges_Request *)malloc(sizeof(rmf_traffic_msgs__srv__RequestChanges_Request));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rmf_traffic_msgs__srv__RequestChanges_Request));
  bool success = rmf_traffic_msgs__srv__RequestChanges_Request__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
rmf_traffic_msgs__srv__RequestChanges_Request__destroy(rmf_traffic_msgs__srv__RequestChanges_Request * msg)
{
  if (msg) {
    rmf_traffic_msgs__srv__RequestChanges_Request__fini(msg);
  }
  free(msg);
}


bool
rmf_traffic_msgs__srv__RequestChanges_Request__Sequence__init(rmf_traffic_msgs__srv__RequestChanges_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rmf_traffic_msgs__srv__RequestChanges_Request * data = NULL;
  if (size) {
    data = (rmf_traffic_msgs__srv__RequestChanges_Request *)calloc(size, sizeof(rmf_traffic_msgs__srv__RequestChanges_Request));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rmf_traffic_msgs__srv__RequestChanges_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rmf_traffic_msgs__srv__RequestChanges_Request__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rmf_traffic_msgs__srv__RequestChanges_Request__Sequence__fini(rmf_traffic_msgs__srv__RequestChanges_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rmf_traffic_msgs__srv__RequestChanges_Request__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rmf_traffic_msgs__srv__RequestChanges_Request__Sequence *
rmf_traffic_msgs__srv__RequestChanges_Request__Sequence__create(size_t size)
{
  rmf_traffic_msgs__srv__RequestChanges_Request__Sequence * array = (rmf_traffic_msgs__srv__RequestChanges_Request__Sequence *)malloc(sizeof(rmf_traffic_msgs__srv__RequestChanges_Request__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = rmf_traffic_msgs__srv__RequestChanges_Request__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
rmf_traffic_msgs__srv__RequestChanges_Request__Sequence__destroy(rmf_traffic_msgs__srv__RequestChanges_Request__Sequence * array)
{
  if (array) {
    rmf_traffic_msgs__srv__RequestChanges_Request__Sequence__fini(array);
  }
  free(array);
}

bool
rmf_traffic_msgs__srv__RequestChanges_Request__Sequence__are_equal(const rmf_traffic_msgs__srv__RequestChanges_Request__Sequence * lhs, const rmf_traffic_msgs__srv__RequestChanges_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rmf_traffic_msgs__srv__RequestChanges_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rmf_traffic_msgs__srv__RequestChanges_Request__Sequence__copy(
  const rmf_traffic_msgs__srv__RequestChanges_Request__Sequence * input,
  rmf_traffic_msgs__srv__RequestChanges_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rmf_traffic_msgs__srv__RequestChanges_Request);
    rmf_traffic_msgs__srv__RequestChanges_Request * data =
      (rmf_traffic_msgs__srv__RequestChanges_Request *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rmf_traffic_msgs__srv__RequestChanges_Request__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          rmf_traffic_msgs__srv__RequestChanges_Request__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rmf_traffic_msgs__srv__RequestChanges_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


bool
rmf_traffic_msgs__srv__RequestChanges_Response__init(rmf_traffic_msgs__srv__RequestChanges_Response * msg)
{
  if (!msg) {
    return false;
  }
  // result
  return true;
}

void
rmf_traffic_msgs__srv__RequestChanges_Response__fini(rmf_traffic_msgs__srv__RequestChanges_Response * msg)
{
  if (!msg) {
    return;
  }
  // result
}

bool
rmf_traffic_msgs__srv__RequestChanges_Response__are_equal(const rmf_traffic_msgs__srv__RequestChanges_Response * lhs, const rmf_traffic_msgs__srv__RequestChanges_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // result
  if (lhs->result != rhs->result) {
    return false;
  }
  return true;
}

bool
rmf_traffic_msgs__srv__RequestChanges_Response__copy(
  const rmf_traffic_msgs__srv__RequestChanges_Response * input,
  rmf_traffic_msgs__srv__RequestChanges_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // result
  output->result = input->result;
  return true;
}

rmf_traffic_msgs__srv__RequestChanges_Response *
rmf_traffic_msgs__srv__RequestChanges_Response__create()
{
  rmf_traffic_msgs__srv__RequestChanges_Response * msg = (rmf_traffic_msgs__srv__RequestChanges_Response *)malloc(sizeof(rmf_traffic_msgs__srv__RequestChanges_Response));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rmf_traffic_msgs__srv__RequestChanges_Response));
  bool success = rmf_traffic_msgs__srv__RequestChanges_Response__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
rmf_traffic_msgs__srv__RequestChanges_Response__destroy(rmf_traffic_msgs__srv__RequestChanges_Response * msg)
{
  if (msg) {
    rmf_traffic_msgs__srv__RequestChanges_Response__fini(msg);
  }
  free(msg);
}


bool
rmf_traffic_msgs__srv__RequestChanges_Response__Sequence__init(rmf_traffic_msgs__srv__RequestChanges_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rmf_traffic_msgs__srv__RequestChanges_Response * data = NULL;
  if (size) {
    data = (rmf_traffic_msgs__srv__RequestChanges_Response *)calloc(size, sizeof(rmf_traffic_msgs__srv__RequestChanges_Response));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rmf_traffic_msgs__srv__RequestChanges_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rmf_traffic_msgs__srv__RequestChanges_Response__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rmf_traffic_msgs__srv__RequestChanges_Response__Sequence__fini(rmf_traffic_msgs__srv__RequestChanges_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rmf_traffic_msgs__srv__RequestChanges_Response__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rmf_traffic_msgs__srv__RequestChanges_Response__Sequence *
rmf_traffic_msgs__srv__RequestChanges_Response__Sequence__create(size_t size)
{
  rmf_traffic_msgs__srv__RequestChanges_Response__Sequence * array = (rmf_traffic_msgs__srv__RequestChanges_Response__Sequence *)malloc(sizeof(rmf_traffic_msgs__srv__RequestChanges_Response__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = rmf_traffic_msgs__srv__RequestChanges_Response__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
rmf_traffic_msgs__srv__RequestChanges_Response__Sequence__destroy(rmf_traffic_msgs__srv__RequestChanges_Response__Sequence * array)
{
  if (array) {
    rmf_traffic_msgs__srv__RequestChanges_Response__Sequence__fini(array);
  }
  free(array);
}

bool
rmf_traffic_msgs__srv__RequestChanges_Response__Sequence__are_equal(const rmf_traffic_msgs__srv__RequestChanges_Response__Sequence * lhs, const rmf_traffic_msgs__srv__RequestChanges_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rmf_traffic_msgs__srv__RequestChanges_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rmf_traffic_msgs__srv__RequestChanges_Response__Sequence__copy(
  const rmf_traffic_msgs__srv__RequestChanges_Response__Sequence * input,
  rmf_traffic_msgs__srv__RequestChanges_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rmf_traffic_msgs__srv__RequestChanges_Response);
    rmf_traffic_msgs__srv__RequestChanges_Response * data =
      (rmf_traffic_msgs__srv__RequestChanges_Response *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rmf_traffic_msgs__srv__RequestChanges_Response__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          rmf_traffic_msgs__srv__RequestChanges_Response__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rmf_traffic_msgs__srv__RequestChanges_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
